#include <linux/config.h>
#include <linux/module.h>
#include <linux/types.h>
#include <linux/string.h>
#include <linux/kernel.h>
#include <linux/delay.h>
#include <linux/timer.h>
#include <linux/mm.h>
#include <linux/ioport.h>
#include <linux/interrupt.h>
#include <linux/major.h>
#include <linux/blkdev.h>
#include <linux/errno.h>
#include <linux/hdreg.h>
#include <linux/genhd.h>
#include <linux/malloc.h>
#include <linux/bios32.h>
#include <linux/pci.h>

#include <asm/byteorder.h>
#include <asm/irq.h>
#include <asm/uaccess.h>
#include <asm/io.h>
#include <asm/bitops.h>

#ifdef CONFIG_KERNELD
#include <linux/kerneld.h>
#endif /* CONFIG_KERNELD */

#include "ide.h"
/*
#define DEBUG_TIVO_STATUS
*/
#include <linux/tivo.h>
#include <linux/ide-tivo.h>
#include <linux/tivo-private.h>

#define MIN(x,y) ((x)<(y)?(x):(y))
#define TRUE 1
#define FALSE !TRUE

void FsIovecInit(struct FsIovecState *state,
                 struct FsIovec *head,
                 int head_len, enum FsIovecMode mode) {
    state->mode = mode; 
    state->top = head;
    state->head = head;
    state->head_len = head_len; 
    state->curr_iovec = state->head;
    state->curr_iovec_bytes = 0;
    state->total_bytes = 0; 
}

int FsIovecTransfer(struct FsIovecState *state, char *ptr, int bytes) {
    int chunk;
    int this_total;

    this_total = 0;
#ifdef DEBUG_TIVO_STATUS3
    printk(KERN_WARNING "FsIovecTransfer: sending %d bytes\n", bytes);
    printk(KERN_WARNING "FsIovecTransfer: head is %p (%d) current %p\n",
           state->head, state->head_len, state->curr_iovec); 
#endif
    while (bytes) { 
        chunk = MIN(bytes,
                    state->curr_iovec->cb - state->curr_iovec_bytes);
#if 0
        printk(KERN_WARNING "FsIovecTransfer: %d bytes to %p+%d (%d bytes left)\n",
               chunk, state->curr_iovec->pb, state->curr_iovec_bytes, bytes);
#endif
        switch(state->mode) {
        case IOVEC_READ:
            TIVO_STATUS2("FsIovecTransfer", "calling memcpy");
            memcpy(state->curr_iovec->pb + state->curr_iovec_bytes,
                   ptr,
                   chunk); 
            break;
        case IOVEC_WRITE:
            memcpy(ptr,
                   state->curr_iovec->pb + state->curr_iovec_bytes,
                   chunk); 
            break;
        default:
            break; 
        }

        TIVO_STATUS("FsIovecTransfer", "memcpy done"); 
        state->curr_iovec_bytes += chunk;
        if (state->curr_iovec_bytes >= state->curr_iovec->cb) {
            state->curr_iovec++;
            state->curr_iovec_bytes = 0;
#ifdef DEBUG_TIVO_STATUS3
            printk(KERN_WARNING "FsIovecTransfer: INCREMENT: head is %p (%d) current %p\n",
                   state->head, state->head_len, state->curr_iovec);
#endif 
        }
        bytes -= chunk;
        ptr += chunk;
        this_total += chunk;
    }
    return(this_total); 
}








